@echo off
rem --- '8_get-epbios-512k-all-stock-sets.cmd' v1.4 by KdL (2022.09.24)

set TIMEOUT=1
set SDBIOSFN=OCM-BIOS.DAT
if "%1"=="" color 1f&title EPBIOS 512kB All Stock Sets
if not exist ..\..\sdbios-k34 color f0&echo.&echo 'sdbios-k34\' not found!&goto quit
if not exist ..\..\sdbios-n34 color f0&echo.&echo 'sdbios-n34\' not found!&goto quit
if not exist ..\..\sdbios-k38-wifi color f0&echo.&echo 'sdbios-k38-wifi\' not found!&goto quit
if not exist ..\..\sdbios-n38-wifi color f0&echo.&echo 'sdbios-n38-wifi\' not found!&goto quit
del /Q *.hex* >nul 2>nul
echo.

set NN=34
set WIFI=
set SCRIPT=6_get-epbios-512k-x34-msx2p.cmd
echo 512kB MSX2/2+/tR BIOS for EPCS16+ (OCM-PLD v3.4 or later)
set YENSLASH=yen&set LONGYENSLASH=yen
call :bin2hex
set YENSLASH=bsl&set LONGYENSLASH=backslash
call :bin2hex
call :collect

set NN=38
set WIFI=-wifi
set SCRIPT=6_get-epbios-512k-x34-msx2p.cmd
echo 512kB MSX2/2+/tR Wi-Fi BIOS for EPCS16+ (OCM-PLD v3.8 or later)
set YENSLASH=yen&set LONGYENSLASH=yen
call :bin2hex
set YENSLASH=bsl&set LONGYENSLASH=backslash
call :bin2hex
call :collect

del %SDBIOSFN%
if "%1"=="" echo.&echo All done!
goto quit

:bin2hex
rem --- MegaSDHC
set KVER=k%NN%
set KERNEL=megasdhc
copy /Y "..\..\sdbios-%KVER%%WIFI%\msx2plus\%KVER%msx2p.%YENSLASH%" %SDBIOSFN% >nul 2>nul
call %SCRIPT% --no-wait&ren ocm_sm_512k.hex ocm_sm_512k_%KERNEL%_%LONGYENSLASH%.hex.msx2plus
copy /Y "..\..\sdbios-%KVER%%WIFI%\msxplusplus\%KVER%msxpp.%YENSLASH%" %SDBIOSFN% >nul 2>nul
call %SCRIPT% --no-wait&ren ocm_sm_512k.hex ocm_sm_512k_%KERNEL%_%LONGYENSLASH%.hex.msxplusplus
copy /Y "..\..\sdbios-%KVER%%WIFI%\msxturbo-r\%KVER%msxtr.%YENSLASH%" %SDBIOSFN% >nul 2>nul
call %SCRIPT% --no-wait&ren ocm_sm_512k.hex ocm_sm_512k_%KERNEL%_%LONGYENSLASH%.hex.msxturbor
copy /Y "..\..\sdbios-%KVER%%WIFI%\sm-x\%KVER%smxbr.%YENSLASH%" %SDBIOSFN% >nul 2>nul
call %SCRIPT% --no-wait&ren ocm_sm_512k.hex ocm_sm_512k_%KERNEL%_%LONGYENSLASH%.hex.smx
copy /Y "..\..\sdbios-%KVER%%WIFI%\sx-2\%KVER%sx2es.%YENSLASH%" %SDBIOSFN% >nul 2>nul
call %SCRIPT% --no-wait&ren ocm_sm_512k.hex ocm_sm_512k_%KERNEL%_%LONGYENSLASH%.hex.sx2
rem copy /Y "..\..\sdbios-%KVER%%WIFI%\u2-sx\%KVER%u2sx.%YENSLASH%" %SDBIOSFN% >nul 2>nul
rem call %SCRIPT% --no-wait&ren ocm_sm_512k.hex ocm_sm_512k_%KERNEL%_%LONGYENSLASH%.hex.u2sx
rem --- Nextor
set KVER=n%NN%
set KERNEL=nextor
copy /Y "..\..\sdbios-%KVER%%WIFI%\msx2plus\%KVER%msx2p.%YENSLASH%" %SDBIOSFN% >nul 2>nul
call %SCRIPT% --no-wait&ren ocm_sm_512k.hex ocm_sm_512k_%KERNEL%_%LONGYENSLASH%.hex.msx2plus
copy /Y "..\..\sdbios-%KVER%%WIFI%\msxplusplus\%KVER%msxpp.%YENSLASH%" %SDBIOSFN% >nul 2>nul
call %SCRIPT% --no-wait&ren ocm_sm_512k.hex ocm_sm_512k_%KERNEL%_%LONGYENSLASH%.hex.msxplusplus
copy /Y "..\..\sdbios-%KVER%%WIFI%\msxturbo-r\%KVER%msxtr.%YENSLASH%" %SDBIOSFN% >nul 2>nul
call %SCRIPT% --no-wait&ren ocm_sm_512k.hex ocm_sm_512k_%KERNEL%_%LONGYENSLASH%.hex.msxturbor
copy /Y "..\..\sdbios-%KVER%%WIFI%\sm-x\%KVER%smxbr.%YENSLASH%" %SDBIOSFN% >nul 2>nul
call %SCRIPT% --no-wait&ren ocm_sm_512k.hex ocm_sm_512k_%KERNEL%_%LONGYENSLASH%.hex.smx
copy /Y "..\..\sdbios-%KVER%%WIFI%\sx-2\%KVER%sx2es.%YENSLASH%" %SDBIOSFN% >nul 2>nul
call %SCRIPT% --no-wait&ren ocm_sm_512k.hex ocm_sm_512k_%KERNEL%_%LONGYENSLASH%.hex.sx2
rem copy /Y "..\..\sdbios-%KVER%%WIFI%\u2-sx\%KVER%u2sx.%YENSLASH%" %SDBIOSFN% >nul 2>nul
rem call %SCRIPT% --no-wait&ren ocm_sm_512k.hex ocm_sm_512k_%KERNEL%_%LONGYENSLASH%.hex.u2sx
goto:eof

:collect
set OUTDIR=epbios-512k-x%NN%%WIFI%
rd /S /Q %OUTDIR% >nul 2>nul
md %OUTDIR% >nul 2>nul
move ocm_sm_512k_* %OUTDIR% >nul 2>nul
goto:eof

:quit
if "%1"=="" waitfor /T %TIMEOUT% pause >nul 2>nul
