@echo off
rem --- 'make-rom.cmd' v1.0 by KdL (2023.10.19)

set "OUT=.rom"

rem --- Low priority
set "ASM=%~dp0tasm.exe"&set "PARAM= -i -e -a13 -80 -b "

rem --- Middle priority
if exist "%~dp0sjasm.exe" ( set "ASM=%~dp0sjasm.exe"&set "PARAM= " )

rem --- High priority
if exist "%~dp0zma.exe" ( set "ASM=%~dp0zma.exe"&set "PARAM= " )

:begin
if "%~n1"=="" goto quit
if not exist "%~dpn1.asm" goto next
pushd "%~dp1"&set "TAB=tasm80.tab"
if not exist "%TAB%" ( copy /Y "%~dp0%TAB%" >nul 2>nul&set "TAB=kill" )

rem --- Assembler execution
echo.&"%ASM%"%PARAM%"%~n1.asm" "%~n1%OUT%" >"%~n1.log"&echo.>>"%~n1.log"
echo "%~n1.asm" has been processed.>>"%~n1.log"&type "%~n1.log"

copy /Y "zma.log" "%~n1.lst" >nul 2>nul&del "zma.log" 2>nul
copy /Y "zma.sym" "%~n1.sym" >nul 2>nul&del "zma.sym" 2>nul
if "%TAB%"=="kill" del "tasm80.tab" 2>nul
popd&if not "%~n2"=="" echo.

:next
shift /1&goto begin

:quit
