@echo off
rem --- '3_extract-roms-k34-msx2p.cmd' v1.1 by KdL (2022.09.24)

set SDBIOSFN=OCM-BIOS.DAT
set OUTDIR=roms-to-concat\
color 1f&title MSX2+ SDBIOS (k34) extracting . . .
if not exist %SDBIOSFN% (
    cd ..
    call make-sdb.cmd %SDBIOSFN% 2
    cd %~dp0
    copy ..\%SDBIOSFN% >nul 2>nul
)
..\bin2hex\splits %SDBIOSFN% 16k >nul 2>nul

copy /B %SDBIOSFN%.001+%SDBIOSFN%.002+%SDBIOSFN%.003+%SDBIOSFN%.004 DISK1OF2.ROM >nul 2>nul
copy /B %SDBIOSFN%.005+%SDBIOSFN%.006+%SDBIOSFN%.007+%SDBIOSFN%.008 DISK2OF2.ROM >nul 2>nul
copy /B %SDBIOSFN%.001+%SDBIOSFN%.002+%SDBIOSFN%.003+%SDBIOSFN%.004+%SDBIOSFN%.005+%SDBIOSFN%.006+%SDBIOSFN%.007+%SDBIOSFN%.008 DISKBIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.009+%SDBIOSFN%.010 MAINBIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.011 XBASBIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.012 MUS-BIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.013 EXT-BIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.014+%SDBIOSFN%.015 KANJBIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.016 OPT-BIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.017+%SDBIOSFN%.018+%SDBIOSFN%.019+%SDBIOSFN%.020+%SDBIOSFN%.021+%SDBIOSFN%.022+%SDBIOSFN%.023+%SDBIOSFN%.024 JIS1BIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.025+%SDBIOSFN%.026+%SDBIOSFN%.027+%SDBIOSFN%.028+%SDBIOSFN%.029+%SDBIOSFN%.030+%SDBIOSFN%.031+%SDBIOSFN%.032 JIS2BIOS.ROM >nul 2>nul
copy ..\ROMS\FREE16KB.ROM FREE16KB.ROM >nul 2>nul
copy ..\ROMS\NULL64KB.ROM NULL64KB.ROM >nul 2>nul

rd /S /Q %OUTDIR% >nul 2>nul
md %OUTDIR% >nul 2>nul
move *.ROM %OUTDIR% >nul 2>nul
del *.0?? >nul 2>nul
del %SDBIOSFN% >nul 2>nul

:quit
