@echo off
rem --- 'make-sdb.cmd' v3.6.1 by KdL (2023.12.04)

setlocal ENABLEDELAYEDEXPANSION

rem --- Texts
set "TITLE=OCM-SDBIOS v3.6.1  "
set "UTITL===================="
set "BUILD=by KdL (2023.12.04)"
set "UBUIL===================="
set "INPUT=Press [ENTER] or input your selection "
set "FIRM1=MSX2+ OCM-PLD v3.0 to v3.3.3"
set "FIRM2=MSX2+ OCM-PLD v3.4 or later"
set "FIRM3=MSXtR OCM-PLD v3.4 or later"
set "FIRM4=512kB dummy blank file to run the EPBIOS"
set "ESPVER=2022.08.13"

rem --- Variables
set TIMEOUT=1
set NOWAIT=0
set ROMDIR=%~dp0ROMS\
set FREE16=%ROMDIR%FREE16KB.ROM
set NULL64=%ROMDIR%NULL64KB.ROM
set TMPDIR=%TEMP%\_SDBIOS_.%RANDOM%\
set PREFIX=K-
set DEFOPT1=2
set DEFOPT2=1
set DEFOPT3=2
set DEFOPT4=2
set DEFOPT5=1
set DEFOPT6=3
set SCRIPTFN=MAKE-SDB
set SDBIOSFN=OCM-BIOS.DAT
set SDBIOSNR=%SDBIOSFN:~0,-1%

rem --- Parameters
set CLEAR1=%~1&set PARAM1=%~1&set PARAM2=%~2&set PARAM3=%~3&set PARAM4=%~4
set PARAM5=%~5&set PARAM6=%~6&set PARAM7=%~7&set PARAM8=%~8&set PARAM9=%~9
if "%PARAM1%"=="" (
    color 1f&title OCM-SDBIOS chaining tool
    set SLEEP=%TIMEOUT%
) else set SLEEP=%NOWAIT%
if /I "%PARAM1%"=="--help" echo.&goto helpMsg
set OUTPUT=%PARAM1%
if "%PARAM2%"=="*" set OPT1=%DEFOPT1%
if "%PARAM2%"=="1" set OPT1=%PARAM2%
if "%PARAM2%"=="2" set OPT1=%PARAM2%
if "%PARAM2%"=="3" set OPT1=%PARAM2%
if "%PARAM2%"=="4" set OPT1=%PARAM2%
if "%PARAM3%"=="*" set OPT2=%DEFOPT2%
if "%PARAM3%"=="1" set OPT2=%PARAM3%
if "%PARAM3%"=="2" set OPT2=%PARAM3%
if "%PARAM3%"=="3" set OPT2=%PARAM3%&if "%OPT1%"=="1" set OPT2=
if "%PARAM4%"=="*" set OPT3=%DEFOPT3%
if "%PARAM4%"=="1" set OPT3=%PARAM4%
if "%PARAM4%"=="2" set OPT3=%PARAM4%
if "%PARAM4%"=="3" set OPT3=%PARAM4%&if "%OPT1%"=="3" set OPT3=
if "%PARAM5%"=="*" set OPT4=%DEFOPT4%
if "%PARAM5%"=="0" set OPT4=%PARAM5%&if "%OPT1%"=="3" set OPT4=
if "%PARAM5%"=="1" set OPT4=%PARAM5%&if "%OPT1%"=="3" set OPT4=
if "%PARAM5%"=="2" set OPT4=%PARAM5%
if "%PARAM5%"=="3" set OPT4=%PARAM5%&if "%OPT1%"=="3" set OPT4=
if "%PARAM5%"=="4" set OPT4=%PARAM5%&if "%OPT1%"=="3" set OPT4=
if "%PARAM5%"=="5" set OPT4=%PARAM5%&if "%OPT1%"=="3" set OPT4=
if "%PARAM5%"=="6" set OPT4=%PARAM5%&if "%OPT1%"=="3" set OPT4=
if "%PARAM5%"=="7" set OPT4=%PARAM5%&if "%OPT1%"=="3" set OPT4=
if "%PARAM5%"=="8" set OPT4=%PARAM5%&if "%OPT1%"=="3" set OPT4=
if "%PARAM5%"=="9" set OPT4=%PARAM5%&if "%OPT1%"=="3" set OPT4=
if /I "%PARAM5%"=="A" set OPT4=%PARAM5%&if "%OPT1%"=="3" set OPT4=
if /I "%PARAM5%"=="B" set OPT4=%PARAM5%&if "%OPT1%"=="3" set OPT4=
if /I "%PARAM5%"=="C" set OPT4=%PARAM5%&if "%OPT1%"=="3" set OPT4=
if "%PARAM6%"=="*" set OPT5=%DEFOPT5%
if "%PARAM6%"=="0" set OPT5=%PARAM6%&if "%OPT1%"=="1" set OPT5=
if "%PARAM6%"=="1" set OPT5=%PARAM6%
if "%PARAM6%"=="2" set OPT5=%PARAM6%&if "%OPT1%"=="1" set OPT5=&if "%OPT1%"=="2" set OPT5=
if "%PARAM6%"=="3" set OPT5=%PARAM6%&if "%OPT1%"=="1" set OPT5=&if "%OPT1%"=="2" set OPT5=
if "%PARAM7%"=="*" set OPT6=%DEFOPT6%
if "%PARAM7%"=="1" set OPT6=%PARAM7%
if "%PARAM7%"=="2" set OPT6=%PARAM7%
if "%PARAM7%"=="3" set OPT6=%PARAM7%
:inputFilename
if "%OUTPUT%"=="" call :helpMsg_0&echo.&set /P OUTPUT="Please insert an output filename or press [ENTER]: "
if "%OUTPUT%"=="" set OUTPUT=%SDBIOSFN%
if "%OUTPUT%"=="*0" set OUTPUT=%SDBIOSNR%0
if "%OUTPUT%"=="*1" set OUTPUT=%SDBIOSNR%1
if "%OUTPUT%"=="*2" set OUTPUT=%SDBIOSNR%2
if "%OUTPUT%"=="*3" set OUTPUT=%SDBIOSNR%3
if "%OUTPUT%"=="*4" set OUTPUT=%SDBIOSNR%4
if "%OUTPUT%"=="*5" set OUTPUT=%SDBIOSNR%5
if "%OUTPUT%"=="*6" set OUTPUT=%SDBIOSNR%6
if "%OUTPUT%"=="*7" set OUTPUT=%SDBIOSNR%7
if "%OUTPUT%"=="*8" set OUTPUT=%SDBIOSNR%8
if "%OUTPUT%"=="*9" set OUTPUT=%SDBIOSNR%9
if "%OUTPUT:~-3%"=="\*0" set OUTPUT=%OUTPUT:\*0=%\%SDBIOSNR%0
if "%OUTPUT:~-3%"=="\*1" set OUTPUT=%OUTPUT:\*1=%\%SDBIOSNR%1
if "%OUTPUT:~-3%"=="\*2" set OUTPUT=%OUTPUT:\*2=%\%SDBIOSNR%2
if "%OUTPUT:~-3%"=="\*3" set OUTPUT=%OUTPUT:\*3=%\%SDBIOSNR%3
if "%OUTPUT:~-3%"=="\*4" set OUTPUT=%OUTPUT:\*4=%\%SDBIOSNR%4
if "%OUTPUT:~-3%"=="\*5" set OUTPUT=%OUTPUT:\*5=%\%SDBIOSNR%5
if "%OUTPUT:~-3%"=="\*6" set OUTPUT=%OUTPUT:\*6=%\%SDBIOSNR%6
if "%OUTPUT:~-3%"=="\*7" set OUTPUT=%OUTPUT:\*7=%\%SDBIOSNR%7
if "%OUTPUT:~-3%"=="\*8" set OUTPUT=%OUTPUT:\*8=%\%SDBIOSNR%8
if "%OUTPUT:~-3%"=="\*9" set OUTPUT=%OUTPUT:\*9=%\%SDBIOSNR%9
if "%OUTPUT:~-1%"=="*" (
    set INAME=*&set PARAM1=*
    if "%OUTPUT:~-2%"=="\*" ( set OUTDIR=%OUTPUT:~0,-1%
    ) else if "%OUTPUT%"=="*" ( set OUTDIR=
           ) else set OUTDIR=%OUTPUT:~0,-1%\
)
if "%PARAM1%"=="*" set OUTPUT=%OUTDIR%%PREFIX%xxxxxx.DAT
set COUNT=0
:loopCOUNT
set /a PLUSONE=%COUNT%+1
if "!OUTPUT:~%COUNT%,1!"=="%%" set OUTPUT=!OUTPUT:~0,%COUNT%!_!OUTPUT:~%PLUSONE%!
if "!OUTPUT:~%COUNT%,1!"=="/" set OUTPUT=!OUTPUT:~0,%COUNT%!_!OUTPUT:~%PLUSONE%!
if "!OUTPUT:~%COUNT%,1!"=="*" set OUTPUT=!OUTPUT:~0,%COUNT%!-!OUTPUT:~%PLUSONE%!
if "!OUTPUT:~%COUNT%,1!"=="?" set OUTPUT=!OUTPUT:~0,%COUNT%!-!OUTPUT:~%PLUSONE%!
set /a COUNT=%COUNT%+1
if not "!OUTPUT:~%COUNT%,1!"=="" goto loopCOUNT
if "%OUTPUT:~-1%"=="\" set OUTPUT=%OUTPUT%%SDBIOSFN%
if "%OUTPUT:~-1%"=="." (
    if "%OUTPUT:~-2%"=="\." ( set OUTPUT=%OUTPUT:~0,-1%%SDBIOSFN%
    ) else if "%OUTPUT%"=="." ( set OUTPUT=%SDBIOSFN%
           ) else set OUTPUT=%OUTPUT:~0,-1%\%SDBIOSFN%
)
if /I "%OUTPUT%"=="--help" set OUTPUT=&goto inputFilename
:exitParameters
set ID=

rem --- Firmware
if "%SLEEP%"=="%NOWAIT%" if "%OPT1%"=="" ( goto printFirmware
                         ) else call :titleMsg&goto notprintFirmware
:printFirmware
cls
echo %TITLE%[Firmware Menu]
echo %UTITL%===============
echo.
echo Output filename: "%OUTPUT%"
echo.
echo 1 = %FIRM1%
echo 2 = %FIRM2%  (default)
echo 3 = %FIRM3% "experimental"
echo 4 = %FIRM4%
echo.
:notprintFirmware
if "%OPT1%"=="" ( set /P ID="%INPUT%(1-4): "&cls
) else set ID=%OPT1%
if "%ID%"=="1" set OPT1=%ID%&goto exitFirmware_0
if "%ID%"=="2" set OPT1=%ID%&goto exitFirmware_0
if "%ID%"=="3" set OPT1=%ID%&goto exitFirmware_0
if "%ID%"=="4" set OPT1=%ID%&set OPT2=0&set OPT3=0&set OPT4=0&set OPT5=0&set OPT6=0&goto saveOutput
if "%ID%"=="-" if "%CLEAR1%"=="" goto clearAll
if not "%ID%"=="" goto exitParameters
set OPT1=%DEFOPT1%
:exitFirmware_0
if "%PARAM1%"=="*" set OUTPUT=%OUTDIR%%PREFIX%%OPT1%xxxxx.DAT
:exitFirmware
set ID=

rem --- Disk-ROM
set DISK=MEGASD1S.ROM"+"%NULL64%
if "%SLEEP%"=="%NOWAIT%" if "%OPT2%"=="" ( goto printDiskROM_1
                         ) else if "%OPT1%"=="1" ( call :titleMsg&goto notprintDiskROM_0
                                ) else call :titleMsg&goto notprintDiskROM_1
:printDiskROM_1
cls
echo %TITLE%[Disk-ROM Menu]
echo %UTITL%===============
echo.
echo Output filename: "%OUTPUT%"
echo.
echo 1 = MegaSDHC FAT16X Single SD-slot  (default)
echo 2 = MegaSDHC FAT16X Double SD-slot
if "%OPT1%"=="1" goto printDiskROM_0
echo 3 = Nextor Kernel v2.1.2 Single SD-slot
echo.
:notprintDiskROM_1
if "%OPT2%"=="" ( set /P ID="%INPUT%(1-3): "&cls
) else set ID=%OPT2%
if "%ID%"=="1" set DISK=MEGASD1S.ROM"+"%NULL64%&set OPT2=%ID%&goto exitDiskROM_0
if "%ID%"=="2" set DISK=MEGASD2S.ROM"+"%NULL64%&set OPT2=%ID%&goto exitDiskROM_0
if "%ID%"=="3" set DISK=NEXTSD1S.ROM&set OPT2=%ID%&goto exitDiskROM_0
goto exitDiskROM_1
:printDiskROM_0
echo.
:notprintDiskROM_0
set DISK=MEGASD1S.ROM
if "%OPT2%"=="" ( set /P ID="%INPUT%(1-2): "&cls
) else set ID=%OPT2%
if "%ID%"=="1" set DISK=MEGASD1S.ROM&set OPT2=%ID%&goto exitDiskROM_0
if "%ID%"=="2" set DISK=MEGASD2S.ROM&set OPT2=%ID%&goto exitDiskROM_0
:exitDiskROM_1
if "%ID%"=="-" if "%CLEAR1%"=="" goto clearAll
if not "%ID%"=="" goto exitFirmware
set OPT2=%DEFOPT2%
:exitDiskROM_0
if "%PARAM1%"=="*" set OUTPUT=%OUTDIR%%PREFIX%%OPT1%%OPT2%xxxx.DAT
set DISK=%ROMDIR%%DISK%
:exitDiskROM
set ID=

rem --- Main-ROM
set MAIN=A1WSXBSL.ROM
if "%SLEEP%"=="%NOWAIT%" if "%OPT3%"=="" ( goto printMainROM_1
                         ) else if "%OPT1%"=="3" ( call :titleMsg&goto notprintMainROM_0
                                ) else call :titleMsg&goto notprintMainROM_1
:printMainROM_1
cls
echo %TITLE%[Main-ROM Menu]
echo %UTITL%===============
echo.
echo Output filename: "%OUTPUT%"
echo.
if "%OPT1%"=="3" goto printMainROM_0
echo 1 = MSX2+ FS-A1WSX Fn-mod Yen
echo 2 = MSX2+ FS-A1WSX Fn-mod Backslash  (default)
echo 3 = MSX2+ FS-A1WSX Fn-mod Western layout
echo.
:notprintMainROM_1
if "%OPT3%"=="" ( set /P ID="%INPUT%(1-3): "&cls
) else set ID=%OPT3%
if "%ID%"=="1" set MAIN=A1WSXYEN.ROM&set OPT3=%ID%&goto exitMainROM_0
if "%ID%"=="2" set MAIN=A1WSXBSL.ROM&set OPT3=%ID%&goto exitMainROM_0
if "%ID%"=="3" set MAIN=A1WSXWST.ROM&set OPT3=%ID%&goto exitMainROM_0
goto exitMainROM_1
:printMainROM_0
echo 1 = MSXtR FS-A1GT Fn-mod Yen
echo 2 = MSXtR FS-A1GT Fn-mod Backslash  (default)
echo.
:notprintMainROM_0
set MAIN=MSXTRBSL.ROM
if "%OPT3%"=="" ( set /P ID="%INPUT%(1-2): "&cls
) else set ID=%OPT3%
if "%ID%"=="1" set MAIN=MSXTRYEN.ROM&set OPT3=%ID%&goto exitMainROM_0
if "%ID%"=="2" set MAIN=MSXTRBSL.ROM&set OPT3=%ID%&goto exitMainROM_0
:exitMainROM_1
if "%ID%"=="-" if "%CLEAR1%"=="" goto clearAll
if not "%ID%"=="" goto exitDiskROM
set OPT3=%DEFOPT3%
:exitMainROM_0
if "%PARAM1%"=="*" set OUTPUT=%OUTDIR%%PREFIX%%OPT1%%OPT2%%OPT3%xxx.DAT
set MAIN=%ROMDIR%%MAIN%
:exitMainROM
set ID=

rem --- Sub-ROM
set SUB=%ROMDIR%2PEXTRTC.ROM
if "%OPT1%"=="1" set SUB=%ROMDIR%2PEXTR01.ROM
if "%OPT1%"=="3" set SUB=%ROMDIR%TREXTRTC.ROM
:exitSubROM
set ID=

rem --- MSX-Music
set MUSIC=%ROMDIR%MSX2PMUS.ROM
if "%OPT1%"=="3" set MUSIC=%ROMDIR%MSXTRMUS.ROM
:exitMSXMusic
set ID=

rem --- Kanji-ROM
set KANJI=KNMSXPPL.ROM
if "%OPT1%"=="3" set KANJI=KN2PLFIX.ROM&goto exitKanjiROM_1
if "%SLEEP%"=="%NOWAIT%" if "%OPT4%"=="" ( goto printKanjiROM_1
                         ) else call :titleMsg&goto notprintKanjiROM_1
:printKanjiROM_1
cls
echo %TITLE%[Kanji-ROM Menu]
echo %UTITL%================
echo.
echo Output filename: "%OUTPUT%"
echo.
echo 0 = No logo
echo 1 = MSX2+ logo fix
echo 2 = MSX++ official logo  (default)
echo 3 = SONY unofficial logo
echo 4 = PHILIPS unofficial logo
echo 5 = Zemmix Neo Korean logo
echo 6 = Zemmix Neo Brazilian logo
echo 7 = SX-1 logo by 8bits4ever
echo 8 = SM-X logo by Victor Trucco
echo 9 = 1chipMSX-Kai logo by HRA^^!
echo A = SX-2 logo by 8bits4ever
echo B = OCM generic unbound logo
echo C = u2-SX logo by Denjhang
echo.
:notprintKanjiROM_1
if "%OPT4%"=="" ( set /P ID="%INPUT%(0-9 or A-C): "&cls
) else set ID=%OPT4%
if "%ID%"=="0" set KANJI=KNNOLOGO.ROM&set OPT4=%ID%&goto exitKanjiROM_0
if "%ID%"=="1" set KANJI=KN2PLFIX.ROM&set OPT4=%ID%&goto exitKanjiROM_0
if "%ID%"=="2" set KANJI=KNMSXPPL.ROM&set OPT4=%ID%&goto exitKanjiROM_0
if "%ID%"=="3" set KANJI=KNSONYUN.ROM&set OPT4=%ID%&goto exitKanjiROM_0
if "%ID%"=="4" set KANJI=KNPHILUN.ROM&set OPT4=%ID%&goto exitKanjiROM_0
if "%ID%"=="5" set KANJI=KNZNEOKR.ROM&set OPT4=%ID%&goto exitKanjiROM_0
if "%ID%"=="6" set KANJI=KNZNEOBR.ROM&set OPT4=%ID%&goto exitKanjiROM_0
if "%ID%"=="7" set KANJI=KNSX-1V2.ROM&set OPT4=%ID%&goto exitKanjiROM_0
if "%ID%"=="8" set KANJI=KNSM-XBR.ROM&set OPT4=%ID%&goto exitKanjiROM_0
if "%ID%"=="9" set KANJI=KNOCMKAI.ROM&set OPT4=%ID%&goto exitKanjiROM_0
if /I "%ID%"=="A" set KANJI=KNSX-2V2.ROM&set OPT4=%ID%&goto exitKanjiROM_0
if /I "%ID%"=="B" set KANJI=KNOCMGUN.ROM&set OPT4=%ID%&goto exitKanjiROM_0
if /I "%ID%"=="C" set KANJI=KNU2SX11.ROM&set OPT4=%ID%&goto exitKanjiROM_0
if "%ID%"=="-" if "%CLEAR1%"=="" goto clearAll
if not "%ID%"=="" goto exitMSXMusic
:exitKanjiROM_1
set OPT4=%DEFOPT4%
:exitKanjiROM_0
if "%PARAM1%"=="*" set OUTPUT=%OUTDIR%%PREFIX%%OPT1%%OPT2%%OPT3%%OPT4%xx.DAT
set KANJI=%ROMDIR%%KANJI%
:exitKanjiROM
set ID=

rem --- Option-ROM
set OPTION=FREE16KB.ROM
if "%OPT1%"=="1" goto exitOptionROM_1
if "%SLEEP%"=="%NOWAIT%" if "%OPT5%"=="" ( goto printOptionROM_1
                         ) else if "%OPT1%"=="3" ( call :titleMsg&goto notprintOptionROM_0
                                ) else call :titleMsg&goto notprintOptionROM_1
:printOptionROM_1
cls
echo %TITLE%[Option-ROM Menu]
echo %UTITL%=================
echo.
echo Output filename: "%OUTPUT%"
echo.
if "%OPT1%"=="3" goto printOptionROM_0
echo 1 = No Option-ROM  (default)
echo 2 = ESP8266 Wi-Fi BIOS %ESPVER%
echo.
:notprintOptionROM_1
if "%OPT5%"=="" ( set /P ID="%INPUT%(1-2): "&cls
) else set ID=%OPT5%
if "%ID%"=="1" set OPTION=FREE16KB.ROM&set OPT5=%ID%&goto exitOptionROM_0
if "%ID%"=="2" set OPTION=ESP8266E.ROM&set OPT5=%ID%&goto exitOptionROM_0
goto exitOptionROM_2
:printOptionROM_0
echo 0 = No logo
echo 1 = MSXtR logo  (default)
echo 2 = ESP8266 Wi-Fi BIOS %ESPVER% + No logo
echo 3 = ESP8266 Wi-Fi BIOS %ESPVER% + MSXtR logo
echo.
:notprintOptionROM_0
set OPTION=MSXTROPT.ROM
if "%OPT5%"=="" ( set /P ID="%INPUT%(0-3): "&cls
) else set ID=%OPT5%
if "%ID%"=="0" set OPTION=EMPTYOPT.ROM&set OPT5=%ID%&goto exitOptionROM_0
if "%ID%"=="1" set OPTION=MSXTROPT.ROM&set OPT5=%ID%&goto exitOptionROM_0
if "%ID%"=="2" set OPTION=ESP8266E.ROM&set OPT5=%ID%&goto exitOptionROM_0
if "%ID%"=="3" set OPTION=ESP8266M.ROM&set OPT5=%ID%&goto exitOptionROM_0
:exitOptionROM_2
if "%ID%"=="-" if "%CLEAR1%"=="" goto clearAll
if not "%ID%"=="" goto exitKanjiROM
:exitOptionROM_1
set OPT5=%DEFOPT5%
:exitOptionROM_0
if "%PARAM1%"=="*" set OUTPUT=%OUTDIR%%PREFIX%%OPT1%%OPT2%%OPT3%%OPT4%%OPT5%x.DAT
set OPTION=%ROMDIR%%OPTION%
:exitOptionROM
set ID=

rem --- JIS1-ROM
set JIS1=%ROMDIR%A1XXJIS1.ROM
:exitJIS1ROM
set ID=

rem --- JIS2-ROM
set JIS2=%ROMDIR%A1XXJIS2.ROM
:exitJIS2ROM
set ID=

rem --- Extra-ROM
set EXTRA=XBASIC21.ROM
if "%SLEEP%"=="%NOWAIT%" if "%OPT6%"=="" ( goto printExtraROM
                         ) else call :titleMsg&goto notprintExtraROM
:printExtraROM
cls
echo %TITLE%[Extra-ROM Menu]
echo %UTITL%================
echo.
echo Output filename: "%OUTPUT%"
echo.
echo 1 = No Extra-ROM
echo 2 = BASIC'n plus v2.0
echo 3 = BASIC'n turbo v2.1  (default)
echo.
:notprintExtraROM
if "%OPT6%"=="" ( set /P ID="%INPUT%(1-3): "&cls
) else set ID=%OPT6%
if "%ID%"=="1" set EXTRA=FREE16KB.ROM&set OPT6=%ID%&goto exitExtraROM_0
if "%ID%"=="2" set EXTRA=XBASIC20.ROM&set OPT6=%ID%&goto exitExtraROM_0
if "%ID%"=="3" set EXTRA=XBASIC21.ROM&set OPT6=%ID%&goto exitExtraROM_0
if "%ID%"=="-" if "%CLEAR1%"=="" goto clearAll
if not "%ID%"=="" goto exitJIS2ROM
set OPT6=%DEFOPT6%
:exitExtraROM_0
set EXTRA=%ROMDIR%%EXTRA%
:exitExtraROM
set ID=

rem --- Chaining of ROMs
:saveOutput
if "%PARAM1%"=="*" set OUTPUT=%OUTDIR%%PREFIX%%OPT1%%OPT2%%OPT3%%OPT4%%OPT5%%OPT6%.DAT
rd /S /Q "%TMPDIR%" >nul 2>nul&md "%TMPDIR%" >nul 2>nul&rem.>"%TMPDIR%FLAGPATH.TMP"
echo F|xcopy /T /E /Y "%TMPDIR%FLAGPATH.TMP" "%OUTPUT%" >nul 2>nul
call :titleMsg
if not exist "%OUTPUT%" echo|set /P="### Creating... "%OUTPUT%" "
if exist "%OUTPUT%" echo|set /P="### Overwriting... "%OUTPUT%" "
if "%OPT1%"=="1" (
    set VERBOSE=%FIRM1%&call :verboseMsg
    copy /B "%FREE16%"+"%FREE16%"+"%FREE16%"+"%FREE16%"+"%FREE16%"+"%FREE16%"+"%FREE16%"+"%FREE16%" "%TMPDIR%BLANK128.TMP" >nul
    copy /B "%DISK%"+"%MAIN%"+"%SUB%"+"%MUSIC%"+"%JIS1%"+"%FREE16%"+"%KANJI%"+"%FREE16%"+"%FREE16%"+"%EXTRA%"+"%FREE16%"+"%FREE16%"+"%TMPDIR%BLANK128.TMP" "%OUTPUT%" >nul
)
if "%OPT1%"=="2" (
    set VERBOSE=%FIRM2%&call :verboseMsg
    copy /B "%DISK%"+"%MAIN%"+"%EXTRA%"+"%MUSIC%"+"%SUB%"+"%KANJI%"+"%OPTION%"+"%JIS1%"+"%JIS2%" "%OUTPUT%" >nul
)
if "%OPT1%"=="3" (
    set VERBOSE=%FIRM3%&call :verboseMsg
    copy /B "%DISK%"+"%MAIN%"+"%EXTRA%"+"%MUSIC%"+"%SUB%"+"%KANJI%"+"%OPTION%"+"%JIS1%"+"%JIS2%" "%OUTPUT%" >nul
)
if "%OPT1%"=="4" (
    set VERBOSE=%FIRM4%&call :verboseMsg
    copy /B "%FREE16%"+"%FREE16%"+"%FREE16%"+"%FREE16%"+"%FREE16%"+"%FREE16%"+"%FREE16%"+"%FREE16%" "%TMPDIR%BLANK128.TMP" >nul
    copy /B "%TMPDIR%BLANK128.TMP"+"%TMPDIR%BLANK128.TMP"+"%TMPDIR%BLANK128.TMP"+"%TMPDIR%BLANK128.TMP" "%OUTPUT%" >nul
)
if "%OUTPUT%"=="%SDBIOSFN%" if not exist "%OUTPUT%" goto errorMsg
if not exist "%OUTPUT%" set PARAM1=&set OUTPUT=%SDBIOSFN%&goto saveOutput
rd /S /Q "%TMPDIR%" >nul 2>nul
if "%SLEEP%"=="%NOWAIT%" goto quit
echo.
echo Done^^!
waitfor /T %SLEEP% pause >nul 2>nul
goto quit

rem --- Error Message
:errorMsg
rd /S /Q "%TMPDIR%" >nul 2>nul
if "%SLEEP%"=="%NOWAIT%" goto quit
color 4f&call :titleMsg
echo ERROR: SOMETHING WENT WRONG^^!
waitfor /T %SLEEP% pause >nul 2>nul
goto quit

rem --- Clear All Selections
:clearAll
set PARAM1=&set OUTPUT=&set OPT1=&set OPT2=&set OPT3=&set OPT4=&set OPT5=&set OPT6=&cls
goto inputFilename

rem --- Extra Description
:verboseMsg
if "%INAME%"=="*" goto verboseOn
if "%PARAM1%"=="" goto verboseOn
set PTEST=--verbose
if /I "%PARAM2%"=="%PTEST%" goto verboseOn
if /I "%PARAM3%"=="%PTEST%" goto verboseOn
if /I "%PARAM4%"=="%PTEST%" goto verboseOn
if /I "%PARAM5%"=="%PTEST%" goto verboseOn
if /I "%PARAM6%"=="%PTEST%" goto verboseOn
if /I "%PARAM7%"=="%PTEST%" goto verboseOn
if /I "%PARAM8%"=="%PTEST%" goto verboseOn
if /I "%PARAM9%"=="%PTEST%" goto verboseOn
echo.
goto:eof
:verboseOn
echo [%VERBOSE%]
goto:eof

rem --- Main Title
:titleMsg
if "%INAME%"=="*" goto titleOn
if "%PARAM1%"=="" goto titleOn
set PTEST=--title
if /I "%PARAM2%"=="%PTEST%" goto titleOn
if /I "%PARAM3%"=="%PTEST%" goto titleOn
if /I "%PARAM4%"=="%PTEST%" goto titleOn
if /I "%PARAM5%"=="%PTEST%" goto titleOn
if /I "%PARAM6%"=="%PTEST%" goto titleOn
if /I "%PARAM7%"=="%PTEST%" goto titleOn
if /I "%PARAM8%"=="%PTEST%" goto titleOn
if /I "%PARAM9%"=="%PTEST%" goto titleOn
goto:eof
:titleOn
cls
echo %TITLE%%BUILD%
echo %UTITL%%UBUIL%
echo.
goto:eof

rem --- Help Message
:helpMsg_0
call :titleMsg
:helpMsg
echo %SCRIPTFN% {[[path\]filename^|*^|.] {[opt1..6] [--title] [--verbose]}} ^| [--help]
echo.
echo ---^| MSX-BIOS Configuration (OCM-PLD v3.4 or later) ^|------------------------
echo.
echo 3-2 (4000h)  128kB  MEGASDHC.ROM + NULL64KB.ROM / NEXTOR  .ROM   blocks 01-08
echo 0-0 (0000h)   32kB  MSX2P   .ROM / MSXTR   .ROM                  blocks 09-10
echo 3-3 (4000h)   16kB  XBASIC2 .ROM / XBASIC21.ROM                  block  11
echo 0-2 (4000h)   16kB  MSX2PMUS.ROM / MSXTRMUS.ROM                  block  12
echo 3-1 (0000h)   16kB  MSX2PEXT.ROM / MSXTREXT.ROM                  block  13
echo 3-1 (4000h)   32kB  MSXKANJI.ROM                                 blocks 14-15
echo 0-3 (4000h)   16kB  FREE16KB.ROM / MSXTROPT.ROM / ESP8266 .ROM   block  16
echo I/O          128kB  JIS1    .ROM                                 blocks 17-24
echo I/O          128kB  JIS2    .ROM                        (512kB)  blocks 25-32
echo -----------------------------------------------------------------------------
goto:eof

:quit
endlocal
