@echo off
rem --- '5_extract-roms-304k-all-stock-sets.cmd' v1.4 by KdL (2022.09.24)

set TIMEOUT=1
set SRC0=epbios-304k-k33\
set DEST=roms-%SRC0%
if "%1"=="" color 1f&title Hex2Bin converter
if not exist %SRC0% goto err_msg
if exist %DEST% if "%1"=="" echo.&echo ### Overwriting... "roms-%SRC0%"
if not exist %DEST% if "%1"=="" echo.&echo ### Creating... "roms-%SRC0%"
set SRC1=emsx_top_304k.hex.
set SRC2=backslash.
set SRC3=msx2
call :extract_k33
set SRC3=msx2plus
call :extract_k33
set SRC3=msxplusplus
call :extract_k33
set SRC3=zemmixneo
call :extract_k33
set SRC3=zemmixneobr
call :extract_k33
set SRC3=sx1
call :extract_k33
set SRC2=yen.
set SRC3=msx2
call :extract_k33
set SRC3=msx2plus
call :extract_k33
set SRC3=msxplusplus
call :extract_k33
set SRC3=zemmixneo
call :extract_k33
set SRC3=zemmixneobr
call :extract_k33
set SRC3=sx1
call :extract_k33

set SRC0=epbios-304k-k34\
set DEST=roms-%SRC0%
if not exist %SRC0% goto err_msg
if exist %DEST% if "%1"=="" echo ### Overwriting... "roms-%SRC0%"
if not exist %DEST% if "%1"=="" echo ### Creating... "roms-%SRC0%"
set SRC1=emsx_top_304k.hex.
set SRC2=backslash.
set SRC3=msx2
call :extract_k34
set SRC3=msx2plus
call :extract_k34
set SRC3=msxplusplus
call :extract_k34
set SRC3=zemmixneo
call :extract_k34
set SRC3=zemmixneobr
call :extract_k34
set SRC3=sx1
call :extract_k34
set SRC2=yen.
set SRC3=msx2
call :extract_k34
set SRC3=msx2plus
call :extract_k34
set SRC3=msxplusplus
call :extract_k34
set SRC3=zemmixneo
call :extract_k34
set SRC3=zemmixneobr
call :extract_k34
set SRC3=sx1
call :extract_k34
if "%1"=="" echo.&echo All done!
goto quit

:extract_k33
hex2bin %SRC0%%SRC1%%SRC2%%SRC3% >nul 2>nul
splits %SRC0%%SRC1%%SRC2%bin 16k >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.001+%SRC0%%SRC1%%SRC2%bin.002+%SRC0%%SRC1%%SRC2%bin.003+%SRC0%%SRC1%%SRC2%bin.004 DISKBIOS.ROM >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.005+%SRC0%%SRC1%%SRC2%bin.006 MAINBIOS.ROM >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.007 EXT-BIOS.ROM >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.008 MUS-BIOS.ROM >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.009+%SRC0%%SRC1%%SRC2%bin.010+%SRC0%%SRC1%%SRC2%bin.011+%SRC0%%SRC1%%SRC2%bin.012+%SRC0%%SRC1%%SRC2%bin.013+%SRC0%%SRC1%%SRC2%bin.014+%SRC0%%SRC1%%SRC2%bin.015+%SRC0%%SRC1%%SRC2%bin.016 JIS1BIOS.ROM >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.017+%SRC0%%SRC1%%SRC2%bin.018 KANJBIOS.ROM >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.019 XBASBIOS.ROM >nul 2>nul
del %SRC0%*.0?? >nul 2>nul
del %SRC0%*.bin >nul 2>nul
rd /S /Q %DEST%%SRC1%%SRC2%%SRC3%\ >nul 2>nul
md %DEST%%SRC1%%SRC2%%SRC3%\ >nul 2>nul
move *.ROM %DEST%%SRC1%%SRC2%%SRC3%\ >nul 2>nul
goto:eof

:extract_k34
hex2bin %SRC0%%SRC1%%SRC2%%SRC3% >nul 2>nul
splits %SRC0%%SRC1%%SRC2%bin 16k >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.001+%SRC0%%SRC1%%SRC2%bin.002+%SRC0%%SRC1%%SRC2%bin.003+%SRC0%%SRC1%%SRC2%bin.004 DISK1OF2.ROM >nul 2>nul
copy /B ..\ROMS\NULL64KB.ROM DISK2OF2.ROM >nul 2>nul
copy /B DISK1OF2.ROM+DISK2OF2.ROM DISKBIOS.ROM >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.005+%SRC0%%SRC1%%SRC2%bin.006 MAINBIOS.ROM >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.007 XBASBIOS.ROM >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.008 MUS-BIOS.ROM >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.009 EXT-BIOS.ROM >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.010+%SRC0%%SRC1%%SRC2%bin.011 KANJBIOS.ROM >nul 2>nul
copy /B %SRC0%%SRC1%%SRC2%bin.012+%SRC0%%SRC1%%SRC2%bin.013+%SRC0%%SRC1%%SRC2%bin.014+%SRC0%%SRC1%%SRC2%bin.015+%SRC0%%SRC1%%SRC2%bin.016+%SRC0%%SRC1%%SRC2%bin.017+%SRC0%%SRC1%%SRC2%bin.018+%SRC0%%SRC1%%SRC2%bin.019 JIS1BIOS.ROM >nul 2>nul
del %SRC0%*.0?? >nul 2>nul
del %SRC0%*.bin >nul 2>nul
rd /S /Q %DEST%%SRC1%%SRC2%%SRC3%\ >nul 2>nul
md %DEST%%SRC1%%SRC2%%SRC3%\ >nul 2>nul
move *.ROM %DEST%%SRC1%%SRC2%%SRC3%\ >nul 2>nul
goto:eof

:err_msg
if "%1"=="" color f0
echo.&echo '%SRC0%%SRC1%%SRC2%%SRC3%' not found!

:quit
if "%1"=="" waitfor /T %TIMEOUT% pause >nul 2>nul
