@echo off
rem --- '1_extract-roms-k33-msx2p.cmd' v1.1 by KdL (2022.09.24)

set SDBIOSFN=OCM-BIOS.DAT
set OUTDIR=roms-to-concat\
color 1f&title MSX2+ SDBIOS (k33) extracting . . .
if not exist %SDBIOSFN% (
    cd ..
    call make-sdb.cmd %SDBIOSFN% 1
    cd %~dp0
    copy ..\%SDBIOSFN% >nul 2>nul
)
..\bin2hex\splits %SDBIOSFN% 16k >nul 2>nul

copy /B %SDBIOSFN%.001+%SDBIOSFN%.002+%SDBIOSFN%.003+%SDBIOSFN%.004 DISKBIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.005+%SDBIOSFN%.006 MAINBIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.007 EXT-BIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.008 MUS-BIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.009+%SDBIOSFN%.010+%SDBIOSFN%.011+%SDBIOSFN%.012+%SDBIOSFN%.013+%SDBIOSFN%.014+%SDBIOSFN%.015+%SDBIOSFN%.016 JIS1BIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.018+%SDBIOSFN%.019 KANJBIOS.ROM >nul 2>nul
copy /B %SDBIOSFN%.022 XBASBIOS.ROM >nul 2>nul
copy ..\ROMS\FREE16KB.ROM OPT-BIOS.ROM >nul 2>nul
copy ..\ROMS\FREE16KB.ROM FREE16KB.ROM >nul 2>nul
copy ..\ROMS\NULL64KB.ROM NULL64KB.ROM >nul 2>nul

rd /S /Q %OUTDIR% >nul 2>nul
md %OUTDIR% >nul 2>nul
move *.ROM %OUTDIR% >nul 2>nul
del *.0?? >nul 2>nul
del %SDBIOSFN% >nul 2>nul

:quit
